//
//  $Id: AppPreferencesInputStream.h,v 1.1.1.1 2000/06/02 22:23:01 sergey Exp $
//

#ifndef _AppPreferencesInputStream_h_
#define _AppPreferencesInputStream_h_

#include "DataInputStream.h"
#include "MemBuffer.h"


namespace Util
{
    //
    //  This class represents an Application preferences as an input data stream.
    //  The process of loading the application preferences could be easily done through
    //  the Serializable interface.
    //
    class AppPreferencesInputStream: public DataInputStream
    {
    public:
        AppPreferencesInputStream();
        virtual ~AppPreferencesInputStream();

    // copy is not alloved
    private:
        AppPreferencesInputStream(const AppPreferencesInputStream& other);
        AppPreferencesInputStream& operator =(const AppPreferencesInputStream& other);

    // operations
    public:
        bool open(DWord creatorID, Word preferencesID);
        void close();

        virtual int readData(void* data, int size) const;
        virtual bool eof() const;

    // data member
    private:
        MemBuffer   _buffer;
        mutable int _position;
    };
}
// namespace Util

#endif // _AppPreferences_h_
